
Requirements:
  * avr-gcc (version 8.3.0 was used for development)
  * avr-binutils (version 2.32)
  * GNU make
  * avrdude for programming
  * simavr-ecl for simulation
  * probably bash

It is recommended to build the software on a GNU/Linux machine.

The following directories should b present:

	.
	├── common
	├── gage1h256c224r008
	│   ├── A
	│   └── B
	└── gage1h256c224r032
	    ├── A
	    └── B

Each instanciation of GAGE has its own directory with subdirectories containing
the different implementations.

The `common` directory contains test-, initialization-, IO-code and common build
settings.

Each implementation directory contains a small Makefile, which makes use of
common make definitions in `common/common.make`.

To build an implementation, `make` can be invoked inside the implementations
directory.

Noteworthy parameters for the build process are:

 * SIMUL (SIMUL=0 or SIMUL=1) define if the program is to be run in a special simulator.
 * AVR_MCU defines the controller for which the software should be compiled
 * PROGRAMMER defines the programmer type to be used for flashing with avrdude
 * PROG_PORT defines the interface to be used for flashing with avrdude

The following build targets are availal:
 
 * build builds the software
 * clean removes all object files
 * flash writes the software into a microcontroller
 * report lists information about the binary size
 * benchrun runs the software in a simulator

Example:

	make SIMUL=0 AVR_MCU=ATMEGA328P PROGRAMMER=avrispmkII PROG_PORT=usb clean flash

Builds and writes the software into an ATmega328P controller via an avr-isp-mkII
programmer.

 
 