GAGE Implementations for AVR microcontrollers
=============================================

This File accompanies a release of optimized implementations of [GAGE][1]
for Microchips / Atmels AVR microcontrollers.

The following instances of GAGE are included in this release:

 * gage1h256c224r008
 * gage1h256c224r032

Since GAGE and InGAGE are cryptographic sponge constructions, the differencing
part of distinct instances is limited to the sponge function.

These sponge functions differ only in the size of the state on which the operate.
InGAGE makes additional use of the same sponge function with half the number of
rounds.

Therefore we investigate only sponge functions of different state sizes, and if
necessary different number of rounds.
These different functions are named after the following pattern:

	gage-core-<n>

and

	gage-core-<n>_2

where `<n>` is the number of bits in the state. The suffix `_2` designates 
functions with half the number of rounds.

The included gage-core functions in this release are:

* gage-core-232
* gage-core-256

Both functions have two different implementations, yielding different tradeoffs:

  Name           |  Cycles  |  RAM  |  ROM
-----------------|----------|-------|-------
gage-core-232 A  |  215273  |   33  |  218
gage-core-232 B  |   34642  |    8  |  478
gage-core-256 A  |  237437  |   36  |  218
gage-core-256 B  |   32778  |    8  |  466

The measurements have been made using the [simavr][2] and an instrumenting
application[3].

The RAM measurment does not include memory necessary to store the state.

Variant B is a bitsliced implementation which also requires the state to be 
padded to a multiple of 8 bytes, which would add 3 bytes to the memory requirement
for gage-core-232 B, but not to the others.

A public [git repository][4] from which this release was derived is also 
available.

[1]: http://gageingage.org/
[2]: https://github.com/buserror/simavr
[3]: https://cryptolib.org/bg/simavr-ecl
[4]: https://cryptolib.org/gage/avr
